/* Erzeuger-Verbraucher-Problem mit Ringpuffer und in/out-Variablen */
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <unistd.h>


#define BUFSIZE 100		  /* Groesse des Puffers 		      */

char *ring;			  /* Zeiger auf Ringpuffer 		      */
int *in,*out;			  /* Zeiger auf in/out-Indizes		      */


void write_element(char element)  /* schreibt ein Element in den Ringpuffer   */
{
}


char read_element()		  /* liest ein Element aus dem Ringpuffer     */
{
}


void erzeuger(int anzahl)	  /* "produziert" anzahl Elemente 	      */
{
int i;

   for(i=1;i<=anzahl;i++) {	  /* Elemente "produzieren" 		      */
      write_element('A');
      printf("Erzeuger     : %d Elemente produziert ...\n",i);
      }
}


void verbraucher(int nr)	  /* "verbraucht" moeglichst viele Elemente   */
				  /* und zaehlt diese 		   	      */
{
int i;
char c;

   i=0;
   
   while (1) {
      c=read_element();
      i++;
      printf("Verbraucher %d: %d Elemente konsumiert ...\n",nr,i);
      }
}


void main(int argc, char *argv[])
{
int	child;			  /* PID des Sohnprozesses		      */
int 	shmID;
   	
        			  /* shared memory anfordern 		      */
   shmID=shmget(IPC_PRIVATE,BUFSIZE+2*sizeof(int),IPC_CREAT|0x1ff);
   				  /* Zeiger auf Ringpuffer initialisieren     */
   ring=(char *)shmat(shmID,NULL,0); 
   in=(int *)(ring+100);	  /* Pointer auf in-Index initialisieren      */ 
   out=in+1;			  /* Pointer auf out-Index initialisieren     */
        
   *in=0;			  /* Indizes initialisieren 		      */
   *out=0;

   child=fork();		  /* Sohnprozess starten 		     */
   if (child==0)		  /* Bin ich der Sohnprozess? 		     */
      erzeuger(10000);		  /* Erzeuger 				     */
   else
      verbraucher(1);		  /* Verbraucher 			     */
}



